#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

#define ADMINISTRACIJA 10
#define BR_PROG 10

// typedef struct _programer {
//     int id;
//     int brProjekta;
// } programer;
// programer lista[BR_PROG];

pthread_mutex_t mutex;
pthread_cond_t cond;
int akcija = 0; //0 - nista, 1 - brisanje, 2 - dodavanje, 3 - citanje, 4 - dodeljivanje
struct lista {
    int id;
    int brProjekta;
    struct lista *sledeci;
};
struct lista *programer;

void *zaposljavanje(void *arg) {
    long idProg = (long)arg;
    printf("Zaposljavanje programera broj %ld\n", idProg);
    struct lista *novi = (struct  lista*)malloc(sizeof(struct lista));
    novi->id = idProg;
    novi->brProjekta = 0;

    pthread_mutex_lock(&mutex);
    while(akcija == 1 || akcija == 2) pthread_cond_wait(&cond, &mutex);

    akcija = 2;
    novi->sledeci = programer;
    programer = novi;
    akcija = 0;
    pthread_cond_broadcast(&cond);
    pthread_mutex_unlock(&mutex);

    printf("Zaposlen programer %ld\n", idProg);

    pthread_exit(NULL);
}

void *otpustanje(void *arg) {
    printf("Otpustanje\n");
    long idProg = (long)arg;
    struct lista *temp;

    pthread_mutex_lock(&mutex);
    while(akcija != 0) pthread_cond_wait(&cond, &mutex);

    akcija = 1;
    pthread_mutex_unlock(&mutex);

    temp = programer;
    // printf("trazi seeee %ld\n", idProg);
    while(temp) {
        if(temp->id == idProg) {
            break;
        }
        temp = temp->sledeci;
    }

    if(temp->id == idProg) {
        struct lista *prethodni, *sledeci;

        while (prethodni->sledeci != temp) {
            prethodni = prethodni->sledeci;
        }
        sledeci = temp->sledeci;

        printf("Programer %ld je otpusten\n", idProg);
        pthread_mutex_lock(&mutex);

        prethodni->sledeci = sledeci;
        free(temp);

        akcija = 0;
        pthread_cond_broadcast(&cond);
        pthread_mutex_unlock(&mutex);
    }
    else {
        printf("Progamer sa id-em %ld nije pronadjen\n", idProg);
        pthread_mutex_lock(&mutex);
        akcija = 0;
        pthread_cond_broadcast(&cond);
        pthread_mutex_unlock(&mutex);
    }

    pthread_exit(NULL);
}

void *dodeljivanje(void *arg) {
    printf("Dodeljivanje\n");
    int *x = (int*)arg;
    struct lista *temp;

    pthread_mutex_lock(&mutex);
    while(akcija == 3) pthread_cond_wait(&cond, &mutex);

    akcija = 4;
    pthread_mutex_unlock(&mutex);

    printf("Trazi se programer broj %d\n", x[0]);
    temp = programer;
    while(temp) {
        if(temp->id == x[0]){
            break;
        }
        temp = temp->sledeci;
    }

    if(temp->id == x[0]) {
        printf("Programer %d je postaveljan na projekat %d\n", x[0], x[1]);
        pthread_mutex_lock(&mutex);
        temp->brProjekta = x[1];
        akcija = 0;
        pthread_cond_broadcast(&cond);
        pthread_mutex_unlock(&mutex);
    }
    else {
        printf("Progamer sa id-em %d nije pronadjen\n", x[0]);
        pthread_mutex_lock(&mutex);
        akcija = 0;
        pthread_cond_broadcast(&cond);
        pthread_mutex_unlock(&mutex);
    }

    pthread_exit(NULL);
}

void *pretrazivanje(void *arg) {
    long x = (long)arg;
    int nezaposleni = 0;
    printf("Pretrazivanje %ld\n", x);

    pthread_mutex_lock(&mutex);
    while(akcija == 1 || akcija == 4) pthread_cond_wait(&cond, &mutex);

    akcija = 3;
    pthread_mutex_unlock(&mutex);

    while(programer) {
        if(programer->brProjekta == 0) {
            nezaposleni++;
        }
        programer = programer->sledeci;
    }

    pthread_mutex_lock(&mutex);
    akcija = 0;
    pthread_cond_broadcast(&cond);
    pthread_mutex_unlock(&mutex);

    if(x < nezaposleni) {
        printf("U kompaniji radi vise od %ld programera bez projekta\n", x);
    }
    else if(x == nezaposleni) {
        printf("U kompaniji radi %ld progamera bez projekta.\n", x);
    }

    pthread_exit(NULL);
}

int main() {
    int tempId = 1;
    pthread_t t[ADMINISTRACIJA];
    pthread_mutex_init(&mutex, NULL);
    pthread_cond_init(&cond, NULL);

    struct lista *novi = (struct  lista*)malloc(sizeof(struct lista));
    for(int i = 0; i < BR_PROG; i++) {
        novi->id = i;
        novi->brProjekta = rand() % 3;
        if(i==0) programer = novi;

        struct lista *temp;
        temp = novi;
        novi = (struct  lista*)malloc(sizeof(struct lista));
        temp->sledeci = novi;
        
        tempId++;
    }
    
    // struct  lista *temp;
    // temp = programer;
    
    // for(int i = 0; i < BR_PROG; i++) {
    //     printf("%d\n", temp->id);
    //     temp = temp->sledeci;
    // }

    for(long i = 0; i < ADMINISTRACIJA; i++) {
        int z[2];
        switch (i % 4)
        {
            case 0:
                pthread_create(t, NULL, pretrazivanje, (void *)(rand()%5));
                break;
            case 1:
                pthread_create(t+i, NULL, zaposljavanje, (void *)(tempId++));
                break;
            case 2:
                z[0] = rand()%tempId;
                z[1] = rand()%5;
                pthread_create(t+i, NULL, dodeljivanje, (void *)z);
                break;
            case 3:
                pthread_create(t+i, NULL, otpustanje, (void *)(rand()%(tempId-1)));
                break;
        }
    }

    for(long i = 0; i < ADMINISTRACIJA; i++) {
        pthread_join(t[i], NULL);
    }

    // struct  lista *temp;
    // temp = programer;
    // while(programer) {
    //     struct  lista *s;
    //     s = temp;
    //     temp = temp->sledeci;
    //     free(s);
    // }

    return 0;
}