#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#include<limits.h>
#include<unistd.h>
#include<pthread.h>

#define r 12
#define x 3

struct l{
    int id;
    int brojProjekata;
    struct l *sledeci;
};

pthread_mutex_t mutex;
pthread_cond_t cond;

int brisanje=0; //ne brise se 0 , brise se 1
int pretrazivanje=0; //ne pretrazuje se 0, pretrazuje se 1
int unos=0; //ne unosi se 0, unosi se 1

void *B(void *tid)
{
    long id = (long)tid;
    struct l* radnik;
    int broj=0;
    
    pthread_mutex_lock(&mutex);
    while(brisanje==1){
        pthread_cond_wait(&cond,&mutex);
    }
    pretrazivanje=1;
    int i;
    while(radnik!=NULL){
        if(radnik->brojProjekata == 0){
            broj++;
        }
        radnik = radnik->sledeci;
    }
    pthread_mutex_unlock(&mutex);

    if(broj==x) printf("radi x programera\n");
    else if(broj>x) printf("radi vise od x programera\n");
    else printf("radi manje od x programera\n");
    sleep(1);

    pthread_mutex_lock(&mutex);
    pretrazivanje=0;
    pthread_cond_broadcast(&cond);
    pthread_mutex_unlock(&mutex);

}

void *Z(void *tid)
{
    long id = (long)tid;
    struct l* radnik;

    pthread_mutex_lock(&mutex);
    while(brisanje==1 || unos==1){
        pthread_cond_wait(&cond, &mutex);
    }
    unos=1;
    while(radnik!=NULL){
        radnik = radnik->sledeci;
    }
    radnik->id=r+1;
    radnik->brojProjekata=0;
    radnik->sledeci = NULL;
    pthread_mutex_unlock(&mutex);

    printf("Unos novog korisnika %d\n", radnik->id);
    sleep(1);

    pthread_mutex_lock(&mutex);
    unos=0;
    pthread_cond_broadcast(&cond);
    pthread_mutex_unlock(&mutex);

}

void *D(void *tid)
{
    long id = (long)tid;
    struct l* radnik;

    int idRadnika=rand()%r;
    int flag = 1;

    pthread_mutex_lock(&mutex);
    while(brisanje==1)
        pthread_cond_wait(&cond, &mutex);
    pretrazivanje = 1;
    while(radnik!=NULL){
        if(radnik->id == idRadnika){
            radnik->brojProjekata++;
            flag = 0;
            break;
        }
        radnik = radnik->sledeci;
    }
    pthread_mutex_unlock(&mutex);

    if(flag==1)
        printf("Nema radnika sa id-jem %d\n", idRadnika);
    else printf("Dodavanje radniku %d novi projekat\n", idRadnika);
    sleep(1);

    pthread_mutex_lock(&mutex);
    pretrazivanje=0;
    pthread_cond_broadcast(&cond);
    pthread_mutex_unlock(&mutex);

}

void *O(void *tid)
{
    long id = (long)tid;
    struct l* radnik;
    struct l* radnikDel;
    int idRadnika = rand()%r;
    int flag=1;

    pthread_mutex_lock(&mutex);
    while(unos==1 || pretrazivanje==1 || brisanje==1)
    {
        pthread_cond_wait(&cond,&mutex);
    }
    brisanje = 1;
    while(radnik!=NULL){
        if(radnik->id == idRadnika)
        {
            flag = 0;
            radnikDel = radnik;
            radnik = radnik->sledeci;
            free(radnikDel);
            break;
        }
        radnik = radnik->sledeci;
    }
    pthread_mutex_unlock(&mutex);

    if(flag==1)
        printf("Nema radnika sa id-jem %d\n", idRadnika);
    else printf("Brisanje radnika sa id-jem %d\n", idRadnika);
    sleep(1);

    pthread_mutex_lock(&mutex);
    brisanje=0;
    pthread_cond_broadcast(&cond);
    pthread_mutex_unlock(&mutex);

}

int main(){
    pthread_t b,z,d,o;
    pthread_t a[4];
    struct l* novi= (struct l*)malloc(sizeof(struct l));

    pthread_mutex_init(&mutex,NULL);
    pthread_cond_init(&cond,NULL);

    for(int i=0;i<r;i++){
        novi->id=i;
        novi->brojProjekata=i;
        novi = novi->sledeci;
    }

    for(long i=0;i<4;i++){
        if(i==0)
            pthread_create(&b, NULL, *B, (void*)i);
        else if(i==1)
            pthread_create(&z, NULL, *Z, (void*)i);
        else if(i==2)
            pthread_create(&d, NULL, *D, (void*)i);
        else if(i==3)
            pthread_create(&o, NULL, *O, (void*)i);
    }

    // for(long i=0;i<r;i++)
    //     pthread_create(&b[i], NULL, *B, (void*)i);
    // for(long i=r;i<2*r;i++)
    //     pthread_create(&z[i], NULL, *Z, (void*)i);
    // for(long i=2*r;i<3*r;i++)
    //     pthread_create(&d[i], NULL, *D, (void*)i);
    // for(long i=3*r;i<4*r;i++)
    //     pthread_create(&o[i], NULL, *O, (void*)i);
    
    // for(long i=0;i<r;i++)
    //     pthread_join(b[i], NULL);
    // for(long i=r;i<2*r;i++)
    //     pthread_join(z[i], NULL);
    // for(long i=2*r;i<3*r;i++)
    //     pthread_join(d[i], NULL);
    // for(long i=3*r;i<4*r;i++)
    //     pthread_join(o[i], NULL);
    
}