#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<time.h>
#include<pthread.h>

int N = 10;
#define X 3
#define P 15

typedef struct programer{
	long id;
	int brojProjekta;
	struct programer *sledeci;
}Programer;

pthread_mutex_t mutex;
pthread_cond_t cond;
Programer *programeri = NULL;
int pretrazivanjeListe = 0;
int brisanjeListe = 0;
int dodavanjeNaPocetakListe = 0;
int postavljaProgrameraNaProjekat = 0;

void *dodaj(Programer **programer, long id)
{
	Programer *novi = (Programer*)malloc(sizeof(Programer)); 
	novi->id = id;
	novi->brojProjekta = 0;
	novi->sledeci = NULL;

	if(*programer == NULL)
		*programer = novi;
	else{
		Programer *temp = *programer;
		while(temp->sledeci != NULL){
			temp = temp->sledeci;
		}
		
		temp->sledeci = novi;
		*programer = temp;
	}
	N++;
}
void *dodajNovogZaposlenog(Programer **programer){
	Programer *novi = (Programer*)malloc(sizeof(Programer)); 
	novi->id = N + 1;
	novi->brojProjekta = 0;
	novi->sledeci = NULL;
	N++;
	novi->sledeci = *programer;
	*programer = novi;
}

void *brisanjeProgramera(Programer **programer, int id)
{
	Programer *prethodni = NULL;
	while((*programer) != NULL){
		if((*programer)->id == id){
			//brisanje
			prethodni->sledeci = (*programer)->sledeci;
			break;		
		}
		prethodni = *programer;
		*programer = (*programer)->sledeci;
			
	}
}

void *f1(void *arg)
{
	long id = (long)arg;

	printf("Zaposleni %ld zeli da pretrazi listu programera.\n", id);

	pthread_mutex_lock(&mutex);
	while(brisanjeListe == 1) //sve dok neko brise listu
		pthread_cond_wait(&cond, &mutex);
	pretrazivanjeListe = 1;
	int brojProgramera = 0;
	while(programeri){
		if(programeri->brojProjekta == 0){
			brojProgramera++;
		}
		programeri = programeri->sledeci;	
	}
	pthread_cond_broadcast(&cond);
	pthread_mutex_unlock(&mutex);
	
	if(brojProgramera > X)
		printf("Zaposleni %ld: U kompaniji trenutno radi vise od %d programera koji nemaju dodeljeni projekat.\n", id, X);
	else
		printf("Zaposleni %ld: U kompaniji trenutno radi manje od %d programera koji nemaju dodeljeni projekat.\n", id, X);

	pthread_mutex_lock(&mutex);
	pretrazivanjeListe = 0;
	pthread_cond_broadcast(&cond);
	pthread_mutex_unlock(&mutex);
}

void *f2(void *arg)
{
	long id = (long)arg;

	printf("Zaposleni %ld zeli da unese programera na pocetak liste.\n", id);
	
	pthread_mutex_lock(&mutex);

	while(brisanjeListe == 1 || dodavanjeNaPocetakListe == 1) 
		pthread_cond_wait(&cond, &mutex);
	
	dodavanjeNaPocetakListe = 1;
	
	dodajNovogZaposlenog(&programeri);
	pthread_mutex_unlock(&mutex);

	printf("Zaposleni %ld je zaposlio novog programera.\n", id);

	pthread_mutex_lock(&mutex);
	dodavanjeNaPocetakListe = 0;
	pthread_cond_broadcast(&cond);
	pthread_mutex_unlock(&mutex);	
}

void *f3(void *arg)
{
	long id = (long)arg;

	printf("Zaposleni %ld zeli da postavi programera na projekat.\n", id);

	pthread_mutex_lock(&mutex);
	while(brisanjeListe == 1 || dodavanjeNaPocetakListe == 1 ||  pretrazivanjeListe == 1)
		pthread_cond_wait(&cond, &mutex);
	postavljaProgrameraNaProjekat == 1;
	int id = rand()%N;
	while(programeri){
		if(programeri->id == id){
			programeri->brojProjekta = P;
			break;
		}
		programeri = programeri->sledeci;	
	}
	
	pthread_mutex_unlock(&mutex);

	pthread_mutex_lock(&mutex);
	postavljaProgrameraNaProjekat = 0;
	pthread_cond_broadcast(&cond);
	pthread_mutex_unlock(&mutex);
}

void *f4(void *arg)
{
	long id = (long)arg;

	printf("Zaposleni %ld zeli da brise iz liste programera.\n", id);
	pthread_mutex_lock(&mutex);
	
	while(brisanjeListe == 1 || dodavanjeNaPocetakListe == 1 ||  pretrazivanjeListe == 1 || postavljaProgrameraNaProjekat == 1) //sve dok neko drugi radi nesto
		pthread_cond_wait(&cond, &mutex);
	brisanjeListe = 1;
	int id = rand()%N;
	brisanjeProgramera(&programeri, id); 
	pthread_mutex_unlock(&mutex);

	pthread_mutex_lock(&mutex);
	brisanjeListe = 0;
	pthread_cond_broadcast(&cond);
	pthread_mutex_unlock(&mutex);	
}

void stampaj(Programer *programeri)
{
	if(programeri){
		printf("%ld %d\n", programeri->id, programeri->brojProjekta);
		programeri = programeri->sledeci;
	}
}

int main()
{
	pthread_t threads[N];
	srand(time(0));

	pthread_mutex_init(&mutex, NULL);
	pthread_cond_init(&cond, NULL);

	for(long i = 1; i <= N; i++){
		dodaj(&programeri, i);
	}
	stampaj(programeri);

	for(long i = 0; i < 4; i++){
		if(i == 0)
			pthread_create(&threads[i], NULL, f1, (void*)i);
		else if(i == 1)
			pthread_create(&threads[i], NULL, f2, (void*)i);
		else if(i == 2)
			pthread_create(&threads[i], NULL, f3, (void*)i);
		else
			pthread_create(&threads[i], NULL, f4, (void*)i);
	}

	for(long i = 0; i < 4; i++){
		pthread_join(threads[i], NULL);
	}

	return 0;
}
