#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>

typedef struct programer
{
    int id;
    int brProjekta;
    struct programer *sledeci;
}Programer;

#define alociraj(x) x=(Programer *)malloc(sizeof(Programer))

#define N 10

pthread_cond_t cond;
pthread_mutex_t mutex;

void dodajUListu(Programer **t,int id)
{
    Programer *novi;
    alociraj(novi);
    novi->id;
    novi->brProjekta=0;
    novi->sledeci=NULL;

    if(*t==NULL)
    {
        *t=novi;
    }
    else{
        Programer *pom=*t;
        novi->sledeci=pom;
        *t=novi;
    }
}
void promeniProjekat(Programer *t,int id,int brProjekta)
{
    Programer *pom=t;
    Programer *pom1=pom->sledeci;

    while(t!=NULL && t->id!=id)
    {
        t=t->sledeci;  
    }
    if(t->id==id)
    {
        t->brProjekta=brProjekta;
    }
    
}


void brisi(Programer **t,int id)
{
    Programer *pom=*t;
    Programer *pom1=pom;
    if(pom->id==id)
    {
        pom=pom->sledeci;
        *t=pom;
    }
    else{
        while (pom!=NULL && pom->id!=id)
        {
            pom1=pom;
            pom=pom->sledeci;
        }
            pom1->sledeci=pom->sledeci; //brise    
        
    }
}

int prebrojProgramere(Programer *p)
{
    int br=0;
    if(p==NULL)
        return 0;
    else
    {
        while (p!=NULL)
        {
            br++;
            p=p->sledeci;       
        }
        return br;  
    }
    
}

int prebrojBezProjekta(Programer *t,int x)
{
    int br=0;
    while(t!=NULL)
    {
        if(t->brProjekta==0)
        br++;

        t=t->sledeci;
    }

    if(br>=x)
        return 1;
    else return 0;
}


void *funkcija(void *arg)
{
    long admin=(long )arg;

    int flagovi[4]={0,0,0,0}; // 0 dodavanja, 1 brisanje, 2 pretrazivanje bez projekta, 3 menjanje projekta

    int operacija=rand()%4; // 0 dodavanja, 1 brisanje, 2 pretrazivanje bez projekta, 3 menjanje projekta

    Programer *p=NULL;
    int id,x,rez;
    int projekat;

   // while(1)
    //{
        if(operacija==0) //dodavanje
        {
            pthread_mutex_lock(&mutex);

            while(flagovi[0] || flagovi[1]) //ako neko dodaje ili brise
                pthread_cond_wait(&cond,&mutex);
            
            flagovi[0]=1;
            id=prebrojProgramere(p)+1;
            projekat=0;
            
            dodajUListu(&p,id);

            pthread_mutex_unlock(&mutex);

            printf("Admin %ld: dodao sam novog programera\n",admin);
            sleep(2);

            pthread_mutex_lock(&mutex);

            flagovi[0]=0;
            pthread_cond_broadcast(&cond);

            pthread_mutex_unlock(&mutex);

            printf("Admin %ld: zavrsio sam sa dodavanje, oslobadjam resurse\n",admin);

            
        }
        else if(operacija==1) //brisanje
        {
            pthread_mutex_lock(&mutex);

            while(flagovi[2] || flagovi[1] || flagovi[0] || flagovi[3]) //ako neko dradi bilo sta
                pthread_cond_wait(&cond,&mutex);
            
            flagovi[1]=1;
            id=rand()%prebrojProgramere(p); //otpustaju nekog programera
            
            brisi(&p,id);

            pthread_mutex_unlock(&mutex);

            printf("Admin %ld: obrisao sam programera %d\n",admin,id);
            sleep(2);

            pthread_mutex_lock(&mutex);

            flagovi[1]=0;
            pthread_cond_broadcast(&cond);

            pthread_mutex_unlock(&mutex);

            printf("Admin %ld: zavrsio sam sa brisanjem, oslobadjam resurse\n",admin);
        }
        else if(operacija==2) // proverava koliko ih je bez projekta
        {
            pthread_mutex_lock(&mutex);

            while( flagovi[1] || flagovi[0] || flagovi[3]) //ako neko brise ili ako dodaje ili menja ne sme, jer ce dodati sa nulom ili promeniti, pa ce ovaj dati netacan broj nezaposlenih
                pthread_cond_wait(&cond,&mutex);
            
            flagovi[2]=1;
            x=rand()%prebrojProgramere(p);
            
            rez=prebrojBezProjekta(p,x);

            pthread_mutex_unlock(&mutex);

            if(rez)
                printf("Admin %ld: postoji %d ili vise programera bez projekta\n",admin,x);
            else
                printf("Admin %ld: ne postoji %d ili vise programera bez projekta\n",admin,x);
            sleep(2);

            pthread_mutex_lock(&mutex);

            flagovi[2]=0;
            pthread_cond_broadcast(&cond);

            pthread_mutex_unlock(&mutex);

            printf("Admin %ld: zavrsio sam sa brojanje bez, oslobadjam resurse\n",admin);
        }
        else if(operacija==3) // promeni projekat
        {
            pthread_mutex_lock(&mutex);

            while( flagovi[1] || flagovi[2]) //ako neko brise ili menja ne sme, jer ce promeniti, pa ce ovaj dati netacan broj nezaposlenih, ako dodaje sme
                pthread_cond_wait(&cond,&mutex);
            
            flagovi[3]=1;
            id=rand()%prebrojProgramere(p);
            projekat=rand()%prebrojProgramere(p);
            
            promeniProjekat(p,id,projekat);

            pthread_mutex_unlock(&mutex);

            printf("Admin %ld: postavio sam programeru %d projekat %d \n",admin,id,projekat);

            pthread_mutex_lock(&mutex);

            flagovi[3]=0;
            pthread_cond_broadcast(&cond);

            pthread_mutex_unlock(&mutex);

            printf("Admin %ld: zavrsio sam sa menjanje, oslobadjam resurse\n",admin);
        }
    //}


}

int main()
{
    pthread_t admin[N];

    pthread_mutex_init(&mutex,NULL);
    pthread_cond_init(&cond,NULL);

    for(long i=0;i<N;i++)
        pthread_create(admin+i,NULL,funkcija,(void *)i);

    for(int i=0;i<N;i++)
        pthread_join(admin[i],NULL);

    return 0;

}