#include<stdio.h>
#include<string.h>
#include<pthread.h>
#include<unistd.h>
#include<time.h>
#include<stdlib.h>
pthread_mutex_t mutex;
pthread_cond_t cond;
pthread_cond_t condSearch;
pthread_cond_t condInsert;
pthread_cond_t condDelete;
pthread_cond_t condUpdate;
#define NUM_THREADS 4
int brisanje=0;
int search=0;
int insert=0;
int update=0;
typedef struct programer{
	int ID;
	int IDPosla;
	struct programer *sledeci;
}Programer;

Programer* searchProgramer(Programer *programeri,int id)
{
	int checker=0;
	Programer *pom=programeri;
	while(pom)
	{
		if(pom->ID==id)
		{
			checker=1;
			printf("Pronasao sam programera sa id %id",id);
			return pom;
		}
		pom=pom->sledeci;
	}
	if(checker==0)
		printf("Nisam pronasao programera");
	return NULL;
	
}

void *dodajNovog(Programer **programeri,int id)
{
	
	Programer *novi=(Programer*)malloc(sizeof(Programer));
	if(!novi)
	{
		printf("Greska pri alokaciji memorije\n");
		exit(0);
	}
	
	novi->ID=id;
	novi->IDPosla=0;
	novi->sledeci=NULL;
	if(*programeri==NULL)
	{
		*programeri=novi;
	}
	else{
		Programer *pom=*programeri;
		novi->sledeci=pom;
		*programeri=novi;
		printf("Uspesno dodat programer %d",id);
		
	}
	
}



int *obrisi(Programer **programeri,int id)
{
	int checker=0;
	Programer *pom2;
	if(*programeri==NULL)
	{
		printf("Lista je prazna\n");
	}
	else
	{
		Programer *pom1=*programeri;
		if((*programeri)->ID==id) //ako je programer na pocetku liste
		{
			pom1=*programeri;
			*programeri=(*programeri)->sledeci;
			free(pom1);
			return 1;
		}
		else{pom1=*programer;
			while(pom1 )
			{ if(pom1->id!=id){
				pom2=pom1; //pamtimo prethodnika
				pom1=pom1->sledeci;
			}
			else{
				if(pom1->sledeci){
				Programer *temp=pom1;
				pom2=pom1->sledeci;
				pom1->sledeci=pom2;
				free(temp);
				return 1;
				}
				
			}
				
			}
			return 0;
		}
		
	}
	
}

void *dodajZadatak(Programer **programeri,int id,idPosla)
{
	Programer *temp=*programeri
	Programer *pom=searchProgramer(programeri,id);
	pom->idPosla=idPosla;
	if(pom!=NULL)
	{
		while(temp){
		if(temp->id=pom->id)
		{
			temp=pom;
		}
		else
			temp=temp->sledeci;
		}
		
	}
	
	
}
void kolikoNemaZadatak(Programer *programeri,int x)
{
	int counter=0;
	while(programeri)
	{
		if(programeri->idPosla==0)
		{
			counter++;
		}
		programeri=programeri->sledeci;
	}
	if(counter==x)
		printf("U kompaniji trenutno radi %d programera koji nemaju dodeljen zadatak");
	else if(counter>x)
		printf("U kompaniji vise od %d programera nema dodeljen posao",x);
	else printf("Manje od %d programera nema posao",x);
	
	pthread_exit(NULL);
}



void *potraziNezaposlene(void *t,Programer programeri)
{
	long tid=(long)t;
	int x=rand()%6;
	while(1){
	pthread_mutex_lock(&mutex);
	while(brisanje!=0)
	{
		pthread_cond_wait(&cond,&mutex);
	}
	
	search++;
	pthread_mutex_unlock(&mutex);
	printf("Administrator %d: Proveravam da li vise od %d programera nema posao",tid,x);
	kolikoNemaZadatak(programeri);
	pthread_mutex_lock(&mutexi);
	search--;
	if(search==0)
	{
		pthread_cond_signal(&condDelete);
	}
	pthread_mutex_unlock(&mutexi);
}
	pthread_exit(NULL);
}

void *zaposliProgramera(void *t)
{
	long tid=(long)t;
	while(1){
	pthread_mutex_lock(&mutex);
	while(insert!=0 && brisanje!=0)
	{
		pthread_cond_wait(&cond,&mutex);
	}
	insert++;
	pthread_mutex_unlock(&mutex);
	int id=rand()%20;
	printf("Administrator %d: Dodajem novog programera.",tid);
	dodajNovog(&programeri,&id);
	pthread_mutex_lock(&mutexi);
	insert--;
	pthread_cond_broadcast(&cond);
	pthread_mutex_unlock(&mutexi);
}
	pthread_exit(NULL);
}

void *obrisiProgramera(void *t,int *id)
{
	long tid=(long)t;
	while(1){
	pthread_mutex_lock(&mutex);
	while(insert!=0 || brisanje!=0 || update!=0 || search!=0)
	{
		pthread_cond_wait(&cond,&mutex);
	}
	brisanje++;
	pthread_mutex_unlock(&mutex);
	int obrisan=rand()%id+1;
	printf("Administrator %d: Brisem %d programera.",tid,obrisan);
	int status=obrisi(&progamer,obrisan);
	sleep(3);
	if(status)
	{
		printf("Administrator %d: Programer %d je uspesno obrisan",tid,obrisan);
	}
	else{
		printf("Administrator %d:Taj administrator vise ne postoji u listi\n");
	}
	pthread_mutex_lock(&mutexi);
	brisanje--;
	if(brisanje==0){
		
		pthread_cond_broadcast(&condInsert);
		pthread_cond_broadcast(&condSearch);
		pthread_cond_broadcast(&condUpdate);
		pthread_cond_broadcast(&condDelete);
	}
	pthread_mutex_unlock(&mutexi);
}
	pthread_exit(NULL);
}

void *dajZadatak(void *t,int id)
{
	//update ista pravila kao insert
	
	long tid=(long)t;
	while(1){
	pthread_mutex_lock(&mutex);
	while(insert!=0 || brisanje!=0 || update!=0)
	{
		pthread_cond_wait(&cond,&mutex);
	}
	update++;
	pthread_mutex_unlock(&mutex);
	printf("Administrator %d: Dodajem zadatak programeru %d"tid,id);
	dodajZadatak(&programeri,id);
	pthread_mutex_lock(&mutexi);
	update--;
	if(update==0)
	{
		pthread_cond_signal(&condDelete);
	}
	pthread_mutex_unlock(&mutexi);
	printf("Adiminstrator %d: Zavrsio sam dodavanje zadatke programeru %d",tid,id);
}
	pthread_exit(NULL);
}

void *work(void *t)
{
	long tid=(long)t;
	
	while(1){
		int posao=rand()%4;
	
	
	}
	
}




int brojProjekta;

int main(){
	pthread_t threads[NUM_THREADS];
	srand(NULL);
	pthread_mutex_init(&mutex);
	pthread_cond_init(&cond);
	long i;
	for(i=0;i<NUM_THREADS;i++)
	{
		int posao=rand()%4;
		switch(posao)
	{	
		case 0:
			pthread_create(thread+i,NULL,potraziNezaposlene,(void*)i);
			break;
		case 1:
		pthread_create(thread+i,NULL,zaposliProgramera,(void *)i);
			break;
		case 2:
			pthread_create(thread+i,NULL,dajZadatak,(void *)i);
			break;
		
		case 3:
			pthread_create(thread+i,NULL,obrisiProgramera,(void *)i);
			break;
	}
	
	}
	
	for(i=0;i<NUM_THREADS;i++)
		pthread_join(&threads[i],NULL);
		
	pthread_mutex_destroy(mutex);
	pthread_exit(NULL);
	
}
