#include<stdio.h>
#include<stdlib.h>
#include<pthread.h>
#include<unistd.h>

#define NUM 5
#define NUM_P 5

struct programer{
    int id;
    int poso;
    struct programer *sledeci;
};

struct argumenti{
    int komeSeDodaje;
    int kojPosoSeDodaje;
};

struct programer *pocetak = NULL;
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond_pret = PTHREAD_COND_INITIALIZER;
pthread_cond_t cond_brisanje = PTHREAD_COND_INITIALIZER;
pthread_cond_t cond_dodavanje = PTHREAD_COND_INITIALIZER;

int trenutno_se_brise = 0;
int trenutno_se_dodaje = 0;
int trenutno_se_pretrazuje = 0;

void dodaj()
{
    printf("pravim novog");
    struct programer *noviPorgramer = (struct programer*)malloc(sizeof(struct programer));
    if(pocetak == NULL)
    {
        printf("POC NULA");
        noviPorgramer->sledeci = NULL;
        noviPorgramer->id = 1;
        noviPorgramer->poso = 0;
        pocetak = noviPorgramer;
    }
    else
    {
        noviPorgramer->id = (pocetak->id) + 1;
        noviPorgramer->poso = 0;
        noviPorgramer->sledeci = pocetak;
        pocetak = noviPorgramer;
    }
    printf("Dodat programer id:%d\n",noviPorgramer->id);
}

void ispisi() //za proveru da li se lisa pravi
{
    struct programer *trenutni = pocetak;
    printf("\n");
    while(trenutni != NULL)
    {
        printf("ID: %d\n",trenutni->id);
        printf("poso: %d\n",trenutni->poso);
        printf("--------------------------\n");
        trenutni = trenutni->sledeci;
    }
}

void pretrazi()
{

}

/*
• Претраживати листу прогамера увек осим у ситуацији да се у датом тренутку врши брисање из листе;
• Уносити новозапосленог програмера на почетак листе, увек сем у ситуацији да се врши брисање или да
други запослени тренутно ради исти посао;
• Брисати из листе, само ако се над листом не врше никакве операције у том тренутку.
*/

void *B_X() //B X - одговарају да ли у компанији тренутно ради X или више програмера који немају додељен пројекат;
{
    int nemaju_poso = 0;
    pthread_mutex_lock(&mutex); //stavlja lock

    while(trenutno_se_brise == 1)
        pthread_cond_wait(&cond_brisanje,&mutex); //da li moze da se pretrazuje (ceka brisanje da se zavrsi)

    trenutno_se_pretrazuje = 1;
    struct programer *trenutni = pocetak;
    while(trenutni != NULL)
    {
        if(trenutni->poso == 0)
            nemaju_poso++;

        trenutni = trenutni->sledeci;
    }
    printf("Trenutno %d programera nemaju poso\n",nemaju_poso);
    pthread_mutex_unlock(&mutex); //sklanja lock
    trenutno_se_pretrazuje = 0;
    pthread_cond_broadcast(&cond_pret); //ako brisanje ceka, moze da nastavi

    pthread_exit(NULL);
}

void *Z() //Z - запошљавају новог програмера;
{
    pthread_mutex_lock(&mutex);

    while(trenutno_se_dodaje == 1)
        pthread_cond_wait(&cond_dodavanje,&mutex);

    while(trenutno_se_brise == 1)
        pthread_cond_wait(&cond_brisanje,&mutex);

    printf("Dodajem novog...");
    trenutno_se_dodaje = 1;
    dodaj();

    pthread_mutex_unlock(&mutex);

    trenutno_se_dodaje = 0;
    pthread_cond_broadcast(&cond_dodavanje);

    pthread_exit(NULL);
}

void *D_ID_P(void *args) //D ID P - постављају програмера ID на пројекат P;
{
    // niko nista ne sme da radi da bi ovo radilo
    struct argumenti *arg = (struct argumenti*) args;
    pthread_mutex_lock(&mutex);

    while(trenutno_se_brise == 1)
        pthread_cond_wait(&cond_brisanje,&mutex);
    
    while(trenutno_se_dodaje == 1)
        pthread_cond_wait(&cond_dodavanje,&mutex);
    
    while(trenutno_se_pretrazuje == 1)
        pthread_cond_wait(&cond_pret,&mutex);

    trenutno_se_brise = 1;
    trenutno_se_dodaje = 1;
    trenutno_se_pretrazuje = 1;
    struct programer *trenutni = pocetak;
    while(trenutni != NULL)
    {
        if(trenutni->id == arg->komeSeDodaje){
            trenutni->poso = arg->kojPosoSeDodaje;
            printf("Programeru %d je dodeljen poso %d\n",trenutni->id,trenutni->poso);
            break;
        }
        trenutni = trenutni->sledeci;
    }
    if(trenutni == NULL)
        printf("Nema programera %d da bismo mu dodelili poso %d\n",arg->komeSeDodaje,arg->kojPosoSeDodaje);
    
    pthread_mutex_unlock(&mutex);

    trenutno_se_brise = 1;
    trenutno_se_dodaje = 1;
    trenutno_se_pretrazuje = 1;
    pthread_cond_broadcast(&cond_dodavanje);
    pthread_cond_broadcast(&cond_brisanje);
    pthread_cond_broadcast(&cond_pret);

    pthread_exit(NULL);
}

void *O_ID(void *id) //O ID - отпуштају програмера ID.
{
    long x_id = (long) id;
    pthread_mutex_lock(&mutex);

    while(trenutno_se_brise == 1)
        pthread_cond_wait(&cond_brisanje,&mutex);
    
    while(trenutno_se_dodaje == 1)
        pthread_cond_wait(&cond_dodavanje,&mutex);
    
    while(trenutno_se_pretrazuje == 1)
        pthread_cond_wait(&cond_pret,&mutex);

    struct programer *trenutni = pocetak;
    struct programer *prethodni = NULL;
    while(trenutni->sledeci != NULL)
    {
        if(trenutni->id == x_id)
        {
            if(trenutni == pocetak) //brisanje pocetka
                pocetak = pocetak->sledeci;
            else if(trenutni->sledeci == NULL){ //brisanje kraja
                if(trenutni->sledeci->id == x_id){
                    trenutni->sledeci = NULL;
                }
            }
            else{ //brisanje negde iz sredine
                prethodni->sledeci = trenutni->sledeci;
                trenutni->sledeci = NULL;
                free(trenutni);
            }
        }
        prethodni = trenutni;
        trenutni = trenutni->sledeci;
    }

    pthread_mutex_unlock(&mutex);
    trenutno_se_brise = 0;
    trenutno_se_dodaje = 0;
    trenutno_se_pretrazuje = 0;

    pthread_cond_broadcast(&cond_dodavanje);
    pthread_cond_broadcast(&cond_brisanje);
    pthread_cond_broadcast(&cond_pret);

    pthread_exit(NULL);
}

int main()
{
    pthread_t administracija[NUM];
    struct argumenti *argument;
    argument = (struct argumenti*)malloc(sizeof(struct argumenti));
    argument->komeSeDodaje = 1;
    argument->kojPosoSeDodaje = 2;
    dodaj();
    dodaj();
    dodaj();

    int dodajPosoID = 1;
    int dodatPoso = 2;
    long obrisiID = 3;

    pthread_create(&administracija[0],NULL,B_X,NULL);
    pthread_create(&administracija[1],NULL,Z,NULL);
    pthread_create(&administracija[2],NULL,D_ID_P,(void *)argument);
    pthread_create(&administracija[3],NULL,O_ID,(void *)obrisiID);

    pthread_join(administracija[0],NULL);
    pthread_join(administracija[1],NULL);
    pthread_join(administracija[2],NULL);
    pthread_join(administracija[3],NULL);



    pthread_exit(NULL);
}