#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#define N 10

pthread_mutex_t mutex;
pthread_cond_t cond;

typedef struct lista{
    int id;
    int broj_projekata;
    struct lista *sledeci;
} Lista;

Lista *programeri;
int brisanje = 0;
int unosenje = 0;
int pretrazivanje = 0;

void *dodaj(Lista **lista, int id){
    Lista *novi = (Lista *)malloc(sizeof(Lista));
    novi -> id =  id;
    novi -> broj_projekata = 0;

    Lista *pom = *lista;

    if(*lista == NULL)
        *lista = novi;
    else{
        pom = (*lista) -> sledeci;
        (*lista) -> sledeci = pom;
    }

    *lista = pom;
}

void *obrisi(Lista **l, int id){
    Lista *pom = *l;

    if(pom -> id == id)
        pom = pom -> sledeci;
    else{
        Lista *pomPreth = pom;
        Lista *pomSledeci = pom -> sledeci;
        while(pomSledeci -> id != id){
            pomPreth = pomPreth -> sledeci;
            pomSledeci = pomSledeci -> sledeci;
        }
            
        pomPreth -> sledeci = pomSledeci -> sledeci;
        
    }
}

Lista *pretrazi(Lista *root, int id){
    Lista *pom = root;
    while(pom -> id != id)
        pom = pom -> sledeci;

    return pom;
}

int prebroj(Lista *l){
    int br = 0;
    while(l){
        if(!(l -> broj_projekata))
            br++;
    }

    return br;
}

void *funkcija(void *arg){

    int func = rand() % 4; // 0 = B, 1 = Z, 2 = D, 3 = O slucajan izbor akcije
    printf("%d - func\n", func);


    if(func == 0){ //B - pretrazivanje
        int x = scanf("%d", &x);

        pthread_mutex_lock(&mutex);

        while(brisanje > 0)
            pthread_cond_wait(&cond, &mutex);

        pretrazivanje++;

        pthread_mutex_unlock(&mutex);

        int br = prebroj(programeri);

        if(br >= x)
            printf("Trenutno radi vise od %d programera bez dodeljenog projekta", x);
        else
            printf("Trenutno ne radi vise od %d programera bez dodeljenog projekta", x);
    
        pthread_mutex_lock(&mutex);
        
        pretrazivanje--;
        pthread_cond_broadcast(&cond);

        pthread_mutex_unlock(&mutex);
    }
    else if(func == 1){ // dodavanje novog programera u listu
        int id = (int)arg + 1; //prepraviti

        pthread_mutex_lock(&mutex);

        while(brisanje > 0 && unosenje > 0)
            pthread_cond_wait(&cond, &mutex);

        unosenje++;

        pthread_mutex_unlock(&mutex);

        dodaj(&programeri, id);
        
        printf("Zaposljen novi programer.\n");

        pthread_mutex_lock(&mutex);
        
        unosenje --;
        pthread_cond_broadcast(&cond);

        pthread_mutex_unlock(&mutex);

    }
    else if(func == 2){ // pretazivanje i dodavanje projekta
        int id = scanf("%d", &id);

        pthread_mutex_lock(&mutex);

        while(brisanje > 0)
            pthread_cond_wait(&cond, &mutex);

        pretrazivanje++;

        pthread_mutex_unlock(&mutex);

        Lista *pom = pretrazi(programeri, id);
        pom -> broj_projekata++;

        printf("Postavljen programer na projekat.\n");

        pthread_mutex_lock(&mutex);

        pretrazivanje--;
        pthread_cond_broadcast(&cond);

        pthread_mutex_unlock(&mutex);

    }
    else{ // O - otpustanje programera sa id-jem
        int id = scanf("%d", &id);

        pthread_mutex_lock(&mutex);

        while(unosenje > 0 && pretrazivanje > 0)
            pthread_cond_wait(&cond, &mutex);

        brisanje++;

        pthread_mutex_unlock(&mutex);

        obrisi(&programeri, id);
        printf("Otpusten je programer sa ID-jem %d.\n", id);

        pthread_mutex_lock(&mutex);

        brisanje--;
        pthread_cond_broadcast(&cond);

        pthread_mutex_unlock(&mutex);

    }

}

int main()
{
    pthread_mutex_init(&mutex, NULL);
    pthread_cond_init(&cond, NULL);

    pthread_t threads[N];

    for(int i = 0; i < N; i ++)
        pthread_create(threads + i, NULL, funkcija, (void *)i);

    for(int i = 0; i < N; i ++)
        pthread_join(threads[i], NULL);

}