#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <stdbool.h>

typedef struct Programer {
    int id;
    int br_projekata;
    struct Programer *sledeci;
}Programer;

enum Zadaci {
    BX,
    Z,
    D_ID_P,
    O_ID
};

#define ADMINISTATORI 10
#define PROGRAMERI 10
Programer *programeri = NULL;; 
bool brisanje = false;
bool drugeOperacije = false;
bool dodavanjeZaposlenog = false;
int idProgramera = 0;
int brojIzbrisanih = 0;

pthread_mutex_t mutex;
pthread_cond_t cond;

int returnRandomId()
{
    int random = rand()%(idProgramera-brojIzbrisanih);
    int brojac = 0;

    Programer *temp = programeri;
    while(temp != NULL)
    {
        brojac++;
        if(temp->sledeci == NULL)
        {
            return temp->id;
        }
        if(brojac == random)
        {
            return temp->id;
        }
        temp = temp->sledeci;
    }
}

void *doWork(void *i)
{
    long t = (long)i;
    sleep(rand()%2); // da ne bi radili u isto vreme
    int zadatak = rand()%4;
    Programer *tempProgramer;

    if(zadatak == O_ID)
    {
        pthread_mutex_lock(&mutex);

        while(drugeOperacije == true)
            pthread_cond_wait(&cond, &mutex);

        brisanje=true;
        int idZaBrisanje = returnRandomId(); //rand()%idProgramera;
        tempProgramer = programeri;
        
        while(tempProgramer != NULL)
        {
            if(tempProgramer->sledeci != NULL)
            {
                if(tempProgramer->id == idZaBrisanje)
                {
                    tempProgramer = tempProgramer->sledeci;
                    break;
                }
            }else{
                if(tempProgramer->id == idZaBrisanje)
                {
                    tempProgramer = NULL;
                    break;
                }
            }
            tempProgramer = tempProgramer->sledeci;
        }
        brojIzbrisanih--;
        printf("Otpustanje programera sa ID-jem %d...\n", idZaBrisanje);
        sleep(1);
        printf("Otpusten.\n");
        brisanje=false;

        pthread_mutex_unlock(&mutex);   
    }
    else{
        pthread_mutex_lock(&mutex);

        drugeOperacije=true;
        if(zadatak == Z)
        {
            while(brisanje == true)
                pthread_cond_wait(&cond, &mutex);
            int broj_projekata = 0;
            tempProgramer = programeri;
            Programer *novi = (struct Programer*)malloc(sizeof(programeri));
            novi->id=idProgramera;
            novi->br_projekata=broj_projekata;
            novi->sledeci = tempProgramer;
            programeri = novi;

            printf("Zaposljavanje novog programera sa ID-jem %d...\n", idProgramera);
            sleep(1);
            printf("Zaposljen!\n");
            idProgramera++;
        }
        else if(zadatak == D_ID_P)
        {
            while(dodavanjeZaposlenog == true && brisanje == true)
                pthread_cond_wait(&cond, &mutex);
            dodavanjeZaposlenog=true;
            tempProgramer = programeri;
            int idZaDodavanjeNovogProjekta = returnRandomId(); //rand()%idProgramera;
            
            while(tempProgramer != NULL)
            {
                if(tempProgramer->id == idZaDodavanjeNovogProjekta)
                {
                    tempProgramer->br_projekata++;
                }
                tempProgramer = tempProgramer->sledeci;
            }

            printf("Dodeljivanje programeru sa ID-jem %d projekat...\n", idZaDodavanjeNovogProjekta);
            sleep(1);
            printf("Dodeljen projekat!\n");
            
            dodavanjeZaposlenog=false;
        }
        else{
            // samo pretraga
            while(brisanje == true)
                pthread_cond_wait(&cond, &mutex);
            int brBezProjekta = 0;
            while(tempProgramer != NULL)
            {
                if(tempProgramer->br_projekata == 0)
                {
                    brBezProjekta++;
                }
                tempProgramer = tempProgramer->sledeci;
            }
            printf("Provera koliko nema bez projekta...\n");
            sleep(1);
            if(brBezProjekta != 0)
            {
                printf("Ukupno %d programera nema projekat...\n", brBezProjekta);
            }
            else{
                printf("Svi imaju projekat.\n");
            }
        }
        drugeOperacije=false;

        pthread_mutex_unlock(&mutex);   
    }
}

int main(int argc, char *argv)
{
    srand(time(NULL));
    long i;
    pthread_t niti[ADMINISTATORI];
    pthread_attr_t attr;
    pthread_mutex_init(&mutex, NULL);
    pthread_attr_init(&attr);
    pthread_cond_init(&cond, NULL);
    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);
    
    // lista programera
    Programer *tempProgramer = programeri;
    for(i = 0; i< PROGRAMERI; i++)
    {
        Programer *novi = (struct Programer*)malloc(sizeof(programeri));
        novi->id=idProgramera;
        novi->br_projekata=rand()%3;
        novi->sledeci=NULL;
        if(tempProgramer == NULL)
            tempProgramer = novi;
        else
        {
            tempProgramer->sledeci=novi;
            tempProgramer = tempProgramer->sledeci;
        }
        if(i==0)
            programeri = novi;
        idProgramera++;
    }


    //kreiranje niti
    for(i =0;i<ADMINISTATORI;i++)
    {
        pthread_create(&niti[i], &attr, (void *)doWork,(void *)i );
    }

    for(i =0;i<ADMINISTATORI;i++)
    {
        pthread_join(niti[i],NULL);
    }

    pthread_mutex_destroy(&mutex);
    pthread_attr_destroy(&attr);
    pthread_cond_destroy(&cond);


    return 0;
}